## ntdb 1.0

=== Makefile ===
# simple makefile wrapper to run waf

WAF=WAF_MAKE=1 PATH=buildtools/bin:../../buildtools/bin:$$PATH waf

all:
	$(WAF) build

install:
	$(WAF) install

uninstall:
	$(WAF) uninstall

test: FORCE
	$(WAF) test $(TEST_OPTIONS)

testenv:
	$(WAF) test --testenv $(TEST_OPTIONS)

quicktest:
	$(WAF) test --quick $(TEST_OPTIONS)

dist:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) dist

distcheck:
	touch .tmplock
	WAFLOCK=.tmplock $(WAF) distcheck

clean:
	$(WAF) clean

distclean:
	$(WAF) distclean

reconfigure: configure
	$(WAF) reconfigure

show_waf_options:
	$(WAF) --help

# some compatibility make targets
everything: all

testsuite: all

.PHONY: check
check: test

torture: all

# this should do an install as well, once install is finished
installcheck: test

etags:
	$(WAF) etags

ctags:
	$(WAF) ctags

pydoctor:
	$(WAF) pydoctor

bin/%:: FORCE
	$(WAF) --targets=`basename $@`
FORCE:

=== wscript ===
#!/usr/bin/env python

APPNAME = 'ntdb'
VERSION = '1.0'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs, glob

samba_dist.DIST_DIRS('lib/ntdb:. lib/replace:lib/replace lib/ccan:lib/ccan buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace,ccan')
    opt.PRIVATE_EXTENSION_DEFAULT('ntdb', noextension='ntdb')
    opt.RECURSE('lib/replace')
    opt.add_option('--valgrind',
                   help=("use valgrind on tests programs"),
                   action="store_true", dest='VALGRIND', default=False)
    opt.add_option('--valgrind-log',
                   help=("where to put the valgrind log"),
                   action="store", dest='VALGRINDLOG', default=None)

    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pyntdb module"),
                       action="store_true", dest='disable_python', default=False)

def configure(conf):
    conf.RECURSE('lib/replace')
    conf.RECURSE('lib/ccan')

    conf.env.NTDB_TEST_RUN_SRC=['test/run-001-encode.c',
                                'test/run-001-fls.c',
                                'test/run-01-new_database.c',
                                'test/run-02-expand.c',
                                'test/run-03-coalesce.c',
                                'test/run-04-basichash.c',
                                'test/run-05-readonly-open.c',
                                'test/run-10-simple-store.c',
                                'test/run-11-simple-fetch.c',
                                'test/run-12-check.c',
                                'test/run-15-append.c',
                                'test/run-25-hashoverload.c',
                                'test/run-30-exhaust-before-expand.c',
                                'test/run-35-convert.c',
                                'test/run-50-multiple-freelists.c',
                                'test/run-56-open-during-transaction.c',
                                'test/run-57-die-during-transaction.c',
                                'test/run-64-bit-tdb.c',
                                'test/run-90-get-set-attributes.c',
                                'test/run-capabilities.c',
                                'test/run-expand-in-transaction.c',
                                'test/run-features.c',
                                'test/run-lockall.c',
                                'test/run-remap-in-read_traverse.c',
                                'test/run-seed.c',
                                'test/run-tdb_errorstr.c',
                                'test/run-tdb_foreach.c',
                                'test/run-traverse.c']
    conf.env.NTDB_TEST_API_SRC=['test/api-12-store.c',
                                'test/api-13-delete.c',
                                'test/api-14-exists.c',
                                'test/api-16-wipe_all.c',
                                'test/api-20-alloc-attr.c',
                                'test/api-21-parse_record.c',
                                'test/api-55-transaction.c',
                                'test/api-60-noop-transaction.c',
                                'test/api-80-tdb_fd.c',
                                'test/api-81-seqnum.c',
                                'test/api-82-lockattr.c',
                                'test/api-83-openhook.c',
                                'test/api-91-get-stats.c',
                                'test/api-92-get-set-readonly.c',
                                'test/api-93-repack.c',
                                'test/api-94-expand-during-parse.c',
                                'test/api-95-read-only-during-parse.c',
                                'test/api-add-remove-flags.c',
                                'test/api-check-callback.c',
                                'test/api-firstkey-nextkey.c',
                                'test/api-fork-test.c',
                                'test/api-locktimeout.c',
                                'test/api-missing-entries.c',
                                'test/api-open-multiple-times.c',
                                'test/api-record-expand.c',
                                'test/api-simple-delete.c',
                                'test/api-summary.c']
    conf.env.NTDB_TEST_API_HELPER_SRC=['test/helpapi-external-agent.c']
    conf.env.NTDB_TEST_RUN_HELPER_SRC=['test/helprun-external-agent.c',
                                       'test/helprun-layout.c']
    conf.env.NTDB_TEST_HELPER_SRC=['test/external-agent.c',
                                   'test/failtest_helper.c',
                                   'test/lock-tracking.c',
                                   'test/logging.c',
                                   'test/tap-interface.c']

    conf.env.standalone_ntdb = conf.IN_LAUNCH_DIR()
    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    if not conf.env.standalone_ntdb:
        if conf.CHECK_BUNDLED_SYSTEM('ntdb', minversion=VERSION,
                                         implied_deps='replace'):
            conf.define('USING_SYSTEM_NTDB', 1)
            if conf.CHECK_BUNDLED_SYSTEM_PYTHON('pyntdb', 'ntdb', minversion=VERSION):
                conf.define('USING_SYSTEM_PYNTDB', 1)

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.find_program('python', var='PYTHON')
        conf.check_tool('python')
        conf.check_python_version((2,4,2))
        conf.SAMBA_CHECK_PYTHON_HEADERS(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pyntdb as python devel libs not found')
            conf.env.disable_python = True

    conf.CHECK_XSLTPROC_MANPAGES()

    # This make #include <ccan/...> work.
    conf.ADD_EXTRA_INCLUDES('''#lib''')

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/ccan')

    if bld.env.standalone_ntdb:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True

    SRC = '''check.c free.c hash.c io.c lock.c open.c
                 summary.c ntdb.c transaction.c traverse.c'''

    if not bld.CONFIG_SET('USING_SYSTEM_NTDB'):
        NTDB_CCAN='ccan-likely ccan-ilog ccan-hash ccan-tally'
        bld.SAMBA_LIBRARY('ntdb',
                          SRC,
                          deps='replace ' + NTDB_CCAN ,
                          includes='.',
                          abi_directory='ABI',
                          abi_match='ntdb_*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers='ntdb.h',
                          public_headers_install=not private_library,
                          pc_files='ntdb.pc',
                          private_library=private_library,
                          manpages='man/ntdb.3')

        bld.SAMBA_BINARY('ntdbtorture',
                         'tools/ntdbtorture.c',
                         deps='ntdb ccan-err',
                         install=False)

        bld.SAMBA_BINARY('ntdbtool',
                         'tools/ntdbtool.c',
                         deps='ntdb', manpages='man/ntdbtool.8')

        bld.SAMBA_BINARY('ntdbdump',
                         'tools/ntdbdump.c',
                         deps='ntdb', manpages='man/ntdbdump.8')

        bld.SAMBA_BINARY('ntdbrestore',
                         'tools/ntdbrestore.c',
                         deps='ntdb', manpages='man/ntdbrestore.8')

        bld.SAMBA_BINARY('ntdbbackup',
                         'tools/ntdbbackup.c',
                         deps='ntdb', manpages='man/ntdbbackup.8')

        if bld.env.DEVELOPER_MODE:
            # FIXME: We need CCAN for some API tests, but waf thinks it's
            # already available via ntdb.  It is, but not publicly.
            # Workaround is to build a private, non-hiding version.
            bld.SAMBA_SUBSYSTEM('ntdb-testing',
                                SRC,
                                deps='replace ' + NTDB_CCAN,
                                includes='.')

            bld.SAMBA_SUBSYSTEM('ntdb-test-helpers',
                                bld.env.NTDB_TEST_HELPER_SRC,
                                deps='replace')
            bld.SAMBA_SUBSYSTEM('ntdb-run-helpers',
                                bld.env.NTDB_TEST_RUN_HELPER_SRC,
                                deps='replace')
            bld.SAMBA_SUBSYSTEM('ntdb-api-helpers',
                                bld.env.NTDB_TEST_API_HELPER_SRC,
                                deps='replace')

            for f in bld.env.NTDB_TEST_RUN_SRC:
                base = os.path.splitext(os.path.basename(f))[0]
                bld.SAMBA_BINARY('ntdb-' + base, f,
                                 deps=NTDB_CCAN + ' ccan-failtest ntdb-test-helpers ntdb-run-helpers',
                                 install=False)

            for f in bld.env.NTDB_TEST_API_SRC:
                base = os.path.splitext(os.path.basename(f))[0]
                bld.SAMBA_BINARY('ntdb-' + base, f,
                                 deps='ntdb-test-helpers ntdb-api-helpers ntdb-testing',
                                 install=False)

        if not bld.CONFIG_SET('USING_SYSTEM_PYNTDB'):
            bld.SAMBA_PYTHON('pyntdb',
                             source='pyntdb.c',
                             deps='ntdb',
                             enabled=not bld.env.disable_python,
                             realname='ntdb.so',
                             cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

def testonly(ctx):
    '''run ntdb testsuite'''
    import Utils, samba_utils, shutil
    ecode = 0;

    env = samba_utils.LOAD_ENVIRONMENT()

    if env.standalone_ntdb:
        # FIXME: This is horrible :(
        test_prefix = "%s/st" % (Utils.g_module.blddir)
        shutil.rmtree(test_prefix, ignore_errors=True)
        os.makedirs(test_prefix)

        # Create scratch directory for tests.
        testdir = os.path.join(test_prefix, 'ntdb-tests')
        samba_utils.mkdir_p(testdir)
        # Symlink back to source dir so it can find tests in test/
        link = os.path.join(testdir, 'test')
        if not os.path.exists(link):
            os.symlink(os.path.abspath(os.path.join(env.cwd, 'test')), link)

        if env.options['VALGRIND']:
            os.environ['VALGRIND'] = 'valgrind -q --num-callers=30 --error-exitcode=11'
        if env.options['VALGRINDLOG']:
            os.environ['VALGRIND'] += ' --log-file=%s' % Options.options.VALGRINDLOG

        for f in env.NTDB_TEST_RUN_SRC + env.NTDB_TEST_API_SRC:
            name = "ntdb-" + os.path.splitext(os.path.basename(f))[0]
            cmd = "cd " + testdir + " && $VALGRIND " + os.path.abspath(os.path.join(Utils.g_module.blddir, name)) + " > test-output 2>&1"
            print("..." + f)
            ret = samba_utils.RUN_COMMAND(cmd)
            if ret != 0:
                print("%s (%s) failed:" % (name, f))
                samba_utils.RUN_COMMAND("cat " + os.path.join(testdir, 'test-output'))
                ecode = ret;
                break;

    sys.exit(ecode)

# WAF doesn't build the unit tests for this, maybe because they don't link with ntdb?
# This forces it
def test(ctx):
    import Scripting
    Scripting.commands.append('build')
    Scripting.commands.append('testonly')

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== debian/changelog ===
ntdb (1.0-9) unstable; urgency=low

  * Drop '-b unstable' flag in Vcs-Git.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 13 Dec 2015 16:08:08 +0000

ntdb (1.0-8) unstable; urgency=medium

  * Avoid duplicating license contents in debian/copyright.

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 04 Dec 2015 17:04:59 +0000

ntdb (1.0-7) unstable; urgency=medium

  * Add reproducible.diff: Make manual page builds reproducible.
  * Fix use of -Wl,--as-needed in LDFLAGS.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 09 May 2015 23:56:14 +0000

ntdb (1.0-6) unstable; urgency=medium

  * debian/copyright: Add short license names, paragraph for main files.
  * Bump standards version to 3.9.6 (no changes).
  * Use -Wl,--as-needed when linking.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 26 Apr 2015 10:28:58 +0000

ntdb (1.0-5) unstable; urgency=medium

  * Use canonical URL in Vcs-Git header.
  * Set branch in Vcs-Git header.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 06 Jul 2014 00:08:56 +0200

ntdb (1.0-4) unstable; urgency=medium

  * Bump standards version to 3.9.5 (no changes).
  * Add missing period at end of ntdb-tools long description. Closes:
    #745693
  * Don't build on hurd-any, as the Hurd does not yet support byte range
    locking. (bug #190367)

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 25 Apr 2014 02:23:08 +0200

ntdb (1.0-3) unstable; urgency=medium

  * Improve spelling of long description. Closes: #737178
  * Drop autopkgtest control flag. Closes: #737542
  * Change maintainer to Debian Samba Maintainers, move myself to
    uploaders.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 03 Feb 2014 23:52:08 +0000

ntdb (1.0-2) unstable; urgency=low

  * Remove broken autopkgtest. Closes: #731593

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 08 Dec 2013 16:08:34 +0000

ntdb (1.0-1) unstable; urgency=low

  * Initial release. Closes: #729165

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 15 Nov 2013 22:06:52 +0000

=== debian/control ===
Source: ntdb
Section: devel
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooij <jelmer@debian.org>
Build-Depends: debhelper (>= 9),
               docbook-xml,
               docbook-xsl,
               python-all-dbg (>= 2.6.6-3),
               python-all-dev (>= 2.6.6-3),
               xsltproc
Homepage: http://tdb.samba.org/
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-samba/ntdb.git

Package: libntdb1
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: linux-any kfreebsd-any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: New Trivial Database - shared library
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 ntdb uses a file format that is incompatible with tdb, but the API
 is similar. It improves performance, adds support for databases
 larger than 4 Gb, and improves integration with talloc.
 .
 This package contains the shared library file.

Package: ntdb-tools
Section: utils
Architecture: linux-any kfreebsd-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: New Trivial Database - bundled binaries
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 ntdb uses a file format that is incompatible with tdb, but the API
 is similar. It improves performance, adds support for databases
 larger than 4 Gb, and improves integration with talloc.
 .
 This package contains bundled test and utility binaries.

Package: libntdb-dev
Section: libdevel
Architecture: linux-any kfreebsd-any
Depends: libc6-dev, libntdb1 (= ${binary:Version}), ${misc:Depends}
Suggests: libtalloc-dev
Description: New Trivial Database - development files
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 ntdb uses a file format that is incompatible with tdb, but the API
 is similar. It improves performance, adds support for databases
 larger than 4 Gb, and improves integration with talloc.
 .
 This package contains the development files.

Package: libntdb1-dbg
Section: debug
Architecture: linux-any kfreebsd-any
Priority: extra
Depends: libntdb1 (= ${binary:Version}), ${misc:Depends}
Recommends: libc6-dbg
Description: New Trivial Database - debug symbols
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 ntdb uses a file format that is incompatible with tdb, but the API
 is similar. It improves performance, adds support for databases
 larger than 4 Gb, and improves integration with talloc.
 .
 This package contains the debug symbols.

Package: python-ntdb
Section: python
Architecture: linux-any kfreebsd-any
Depends: libntdb1 (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Provides: ${python:Provides}
Description: Python bindings for NTDB
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 ntdb uses a file format that is incompatible with tdb, but the API
 is similar. It improves performance, adds support for databases
 larger than 4 Gb, and improves integration with talloc.
 .
 This package contains the Python bindings.

Package: python-ntdb-dbg
Section: debug
Architecture: linux-any kfreebsd-any
Priority: extra
Depends: python-ntdb (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: python-dbg, libntdb1-dbg
Provides: ${python:Provides}
Description: Python bindings for NTDB - debug extension
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 ntdb uses a file format that is incompatible with tdb, but the API
 is similar. It improves performance, adds support for databases
 larger than 4 Gb, and improves integration with talloc.
 .
 This package contains the Python debug extension.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

CFLAGS += -g -Wall
LDFLAGS += -Wl,--as-needed

DESTDIR=$(CURDIR)/debian/tmp
export PYTHON=$(shell which `pyversions -d`)
export PYTHON_CONFIG=$(PYTHON)-config

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $* --with python2

override_dh_auto_configure:
	PYTHON="$(PYTHON)" PYTHON_CONFIG="$(PYTHON_CONFIG)" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		   ./configure --prefix=/usr --disable-rpath-install --libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_python2:
	dh_python2 --no-guessing-versions

override_dh_auto_build:
	$(MAKE) all

override_dh_auto_test:
	echo "Testsuite disabled, since it currently requires developer mode."
#ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
#	$(MAKE) check
#endif

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf build
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8854
	rm -f .lock-wscript
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8855
	rm -f buildtools/wafsamba/*.pyc \
		  buildtools/wafadmin/*.pyc \
		  buildtools/wafadmin/Tools/*.pyc

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(DESTDIR)
	# Waf should be doing this..
	ar cr libntdb.a bin/default/*.o bin/default/lib/ccan/*/*.o
	mv libntdb.a $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip -p libntdb1 --dbg-package=libntdb1-dbg
	dh_strip -p python-ntdb --dbg-package=python-ntdb-dbg
	dh_strip -p ntdb-tools

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

=== debian/watch ===
version=3
http://ftp.samba.org/pub/tdb ntdb-(.+).tar.gz
